//
//  IAAppDelegate.m
//  SaleAlerts
//
//  Created by Martín Conte Mac Donell on 7/16/13.
//  Copyright (c) 2013 iOS in Action. All rights reserved.
//

#import "IAViewController.h"
#import "IAAppDelegate.h"

@implementation IAAppDelegate

- (void)applicationDidFinishLaunching:(UIApplication *)application
{
    [[UIApplication sharedApplication] registerForRemoteNotificationTypes:
     (UIRemoteNotificationTypeSound | UIRemoteNotificationTypeAlert)];
}

- (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken
{
    NSLog(@"Device Token: %@", deviceToken);
}


- (void)application:(UIApplication *)application didReceiveRemoteNotification:(NSDictionary *)userInfo
{
    IAViewController *viewController = (IAViewController *)[[self window] rootViewController];
    NSDictionary *alert = userInfo[@"aps"][@"alert"];
    [[viewController offerLabel] setText:alert[@"body"]];

    UILocalNotification *localNotification = [[UILocalNotification alloc] init];
    localNotification.fireDate = [NSDate dateWithTimeIntervalSinceNow:10];
    localNotification.alertBody = alert[@"body"];
    [[UIApplication sharedApplication] scheduleLocalNotification:localNotification];
}

@end
