//
//  IABallBounceBehavior.m
//  Motion Ball
//
//  Created by Brendan G. Lim on 11/4/13.
//  Copyright (c) 2013 iOS in Action. All rights reserved.
//

#import "IABallBounceBehavior.h"

@implementation IABallBounceBehavior

-(id) initWithItems:(NSArray *)items
{
    if (self = [super init]) {
        UIGravityBehavior *gravity = [[UIGravityBehavior alloc] initWithItems:items];
        [self addChildBehavior:gravity];
        
        UICollisionBehavior *collision = [[UICollisionBehavior alloc] initWithItems:items];
        collision.translatesReferenceBoundsIntoBoundary = YES;
        [self addChildBehavior:collision];
        
        UIDynamicItemBehavior *dynamic = [[UIDynamicItemBehavior alloc] initWithItems:items];
        for (UIView *item in items)
            [dynamic addAngularVelocity:0.2f forItem:item];

        dynamic.elasticity = 0.8f;
        dynamic.friction = 0.2f;
        dynamic.density = 0.4f;
        [self addChildBehavior:dynamic];
    }
    
    return self;
}

@end
