//
//  IAViewController.m
//  Motion Ball
//
//  Created by Brendan G. Lim on 11/3/13.
//  Copyright (c) 2013 iOS in Action. All rights reserved.
//

#import "IAViewController.h"
#import "IABallBounceBehavior.h"

@interface IAViewController ()

@end

@implementation IAViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self addParallaxEffect];
    
    self.animator = [[UIDynamicAnimator alloc] initWithReferenceView:self.view];
    [self.basketball setUserInteractionEnabled:YES];
    
    [self setupGravity];
}

- (void) setupGravity
{
    UITapGestureRecognizer *tapGesture = [[UITapGestureRecognizer alloc] initWithTarget:self
                                                                                 action:@selector(applyGravity:)];
    [self.basketball addGestureRecognizer:tapGesture];
}

- (void) applyGravity:(UITapGestureRecognizer *)recognizer
{
    IABallBounceBehavior *ballBounce = [[IABallBounceBehavior alloc] initWithItems:@[self.basketball]];
    [self.animator addBehavior:ballBounce];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (void) addParallaxEffect
{
    UIInterpolatingMotionEffect *verticalEffect = [[UIInterpolatingMotionEffect alloc] initWithKeyPath:@"center.x"
                                                                                                  type:UIInterpolatingMotionEffectTypeTiltAlongHorizontalAxis];

    UIInterpolatingMotionEffect *horizontalEffect = [[UIInterpolatingMotionEffect alloc] initWithKeyPath:@"center.y"
                                                                                                    type:UIInterpolatingMotionEffectTypeTiltAlongVerticalAxis];

    verticalEffect.maximumRelativeValue = @(20);
    verticalEffect.minimumRelativeValue = @(-20);

    horizontalEffect.maximumRelativeValue = @(20);
    horizontalEffect.minimumRelativeValue = @(-20);
    
    [self.basketball addMotionEffect:verticalEffect];
    [self.basketball addMotionEffect:horizontalEffect];
}

@end
