//
//  IAViewController.m
//  Retrieving Remote Data
//
//  Created by Martín Conte Mac Donell on 5/11/13.
//

#import "IAViewController.h"
#import "IAHTTPCommunication.h"
#import "IAWebViewController.h"

@interface IAViewController () {
    NSNumber *jokeID;
}

@property (weak, nonatomic) IBOutlet UILabel *jokeLabel;

@end

@implementation IAViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self retrieveRandomJokes:self];
}

- (IBAction)thumbUp:(id)sender
{
    [self retrieveRandomJokes:nil];

    NSURL *url = [NSURL URLWithString:@"http://example.com/rater/vote"];
    IAHTTPCommunication *http = [[IAHTTPCommunication alloc] init];
    NSDictionary *params = @{@"joke_id": jokeID, @"vote": @(1)};

    [http postURL:url params:params successBlock:^(NSData *response) {
        NSLog(@"Voted Up!");
    }];
}

- (IBAction)thumbDown:(id)sender
{
    [self retrieveRandomJokes:nil];
    
    NSURL *url = [NSURL URLWithString:@"http://example.com/rater/vote"];
    IAHTTPCommunication *http = [[IAHTTPCommunication alloc] init];
    NSDictionary *params = @{@"joke_id": jokeID, @"vote": @(-1)};

    [http postURL:url params:params successBlock:^(NSData *response) {
        NSLog(@"Voted Down!");
    }];
}

- (IBAction)retrieveRandomJokes:(id)sender
{
    IAHTTPCommunication *http = [[IAHTTPCommunication alloc] init];
    [http retreiveURL:[NSURL URLWithString:@"http://api.icndb.com/jokes/random"]
         successBlock:^(NSData *response)
     {
         NSError *error = nil;
         NSDictionary *data = [NSJSONSerialization JSONObjectWithData:response
                                                              options:0
                                                                error:&error];
         if (!error)
         {
             NSDictionary *value = data[@"value"];
             if (value && value[@"joke"])
             {
                 jokeID = value[@"id"];
                 [self.jokeLabel setText:value[@"joke"]];
             }
         }
     }];
}

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    IAWebViewController *wb = [segue destinationViewController];
    [wb setURL:[NSURL URLWithString:@"https://en.wikipedia.org/wiki/Chuck_Norris"]];
}

@end
