//
//  IAAnalogClockView.m
//  AnimatedClock
//
//  Created by Martín Conte Mac Donell on 6/30/13.
//  Copyright (c) 2013 iOS in Action. All rights reserved.
//

#import <QuartzCore/QuartzCore.h>
#import "IAAnalogClockView.h"

@interface IAAnalogClockView () {
    CGFloat pendulumAngle;
}

@property (nonatomic, weak) IBOutlet UIView *pendulum;
@property (nonatomic, weak) IBOutlet UIView *minutesHand;
@property (nonatomic, weak) IBOutlet UIView *secondsHand;
@property (nonatomic, weak) IBOutlet UIView *hoursHand;

@end

@implementation IAAnalogClockView

- (void)didMoveToWindow
{
    [NSTimer scheduledTimerWithTimeInterval:1.0
                                     target:self
<<<<<<< HEAD
                                   selector:@selector(moveNeedlesToLocalTime)
=======
                                   selector:@selector(moveHandsToLocalTime)
>>>>>>> 06c81994a5b14379a26a403c86f28c43e6d40334
                                   userInfo:nil
                                    repeats:YES];
    [self oscillatePendulum];
}

- (void)moveHand:(UIView *)hand toAngle:(CGFloat)angle
{
    [[hand layer] setAnchorPoint:CGPointMake(0.4f, 0.75f)];
    [[hand layer] setPosition:CGPointMake(165.0f, 175.0f)];

    
    [UIView animateWithDuration:0.5f
                     animations:^
    {
        CGAffineTransform matrix = CGAffineTransformMakeRotation(angle * M_PI / 180);
        [[hand layer] setAffineTransform:matrix];
    }];
}

- (void)moveHandsToLocalTime
{
    NSCalendar *calendar = [NSCalendar currentCalendar];
    NSInteger comp = (NSHourCalendarUnit | NSMinuteCalendarUnit | NSSecondCalendarUnit);
    NSDateComponents *components = [calendar components:comp fromDate:[NSDate date]];
    
    [self moveHand:self.hoursHand toAngle:[components hour] * 360.0f / 24.0f];
    [self moveHand:self.minutesHand toAngle:[components minute] * 360.0f / 60.0f];
    [self moveHand:self.secondsHand toAngle:[components second] * 360.0f / 60.0f];
}

- (void)oscillatePendulum
{
    [[self.pendulum layer] setAnchorPoint:CGPointMake(0.5f, 0.0f)];
    [[self.pendulum layer] setPosition:CGPointMake(165.0f, 175.0f)];

    CAKeyframeAnimation *animation = [CAKeyframeAnimation animationWithKeyPath:@"transform.rotation.z"];
    animation.duration = 1.5f;
    animation.repeatCount = INT64_MAX;
    animation.values = @[@(0.0f * M_PI / 180.0f), @(15.0f * M_PI / 180.0f),
                         @(0.0f * M_PI / 180.0f), @(-15.0f * M_PI / 180.0f),
                         @(0.0f * M_PI / 180.0f)];

    animation.keyTimes = @[@(0.0f), @(0.26f), @(0.50f), @(0.74f), @(1.0f)];
    animation.timingFunctions = @[
       [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseOut],
       [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseIn],
       [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseOut],
       [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseIn],
    ];
    
    [[self.pendulum layer] addAnimation:animation forKey:nil];
}

@end
